
-- Vypocet korenu kvadraticke rovnice s pouzitim funkce definovane v modulu
-- O. Rohlik, 2002 

with TEXT_IO;
use TEXT_IO;
with Ada.Numerics.Elementary_Functions;
use Ada.Numerics.Elementary_Functions;
with Diskriminant;
use Diskriminant;
    
procedure main is
  -- deklarace
  a,b,c,d,x1,x2 : FLOAT;
  package MyFloat_IO is new FLOAT_IO(FLOAT);
  use MyFloat_IO;
  
  --function Disk (a,b,c:float) returns float;
  --function Disk (a,b,c:float) return float is
  --begin
  --    return B**2-4.0*A*C;
  --end;

begin
  new_line;
  put_line("+-----------------------------------------------------+");
  put_line("| Program na vypocet korenu kvadraticke rovnice tvaru |");
  put_line("|                                                     |");
  put_line("|               a*x^2 + b*x + c = 0                   |");
  put_line("+-----------------------------------------------------+");
  new_line;
  new_line;
  put("Zadej koeficient a: ");
  get(A);
  put("Zadej koeficient b: ");
  get(B);
  put("Zadej koeficient c: ");
  get(C);
  
  D := Disk(a,b,c);
  new_line;
  put("( Diskriminant je: ");   
  put(D, 1, 2, 0); -- posledni tri parametry jsou jen na formatovani vystupu realneho cisla
  put(" )");   
  new_line;
  new_line;
  
  if D = 0.0 then 
    put("Existuje jedno reseni v R a to je: ");   
    put(-B/(2.0*A), 5, 2, 0); 
  elsif D > 0.0 then 
    put("Existuji dve reseni v R a to: ");   
    put((-B+Ada.Numerics.Elementary_Functions.sqrt(D))/(2.0*A), 5, 2, 0);
    put(" a ");   
    put((-B-sqrt(D))/(2.0*A), 5, 2, 0);
  else
    put("Neexistuje reseni v R.");       
  end if;
end main;    

